import java.util.ArrayList;
import java.util.Iterator;
import java.util.Scanner;

/**
 * A class to hold details of audio files.
 * 
 * @author David J. Barnes and Michael K�lling
 * @version 2011.07.31
 */
public class MusicCollection
{
    // An ArrayList for storing the file names of music files.
    private ArrayList<Music> files;
    // A player for the music files.
    private MusicPlayer player;
    //fav musics list
    private ArrayList<Music> favorateMusics;
        
    /**
     * Create a MusicCollection
     */
    public MusicCollection()
    {
        files=new ArrayList<Music>();
        favorateMusics=new ArrayList<>();
    }
    
    /**
     * Add a file to the collection.
     * @param filename The file to be added.
     */
    public void addFile(String filename)
    {
        Scanner scanner= new Scanner(System.in);
        System.out.println("name of producer");
        String producer=scanner.nextLine();
        System.out.println("address");
        String address=scanner.nextLine();
        System.out.println("publish year");
        int publish=scanner.nextInt();
        scanner.nextLine();
    files.add(new Music(filename,producer,publish,address));
    }
    
    /**
     * Return the number of files in the collection.
     * @return The number of files in the collection.
     */
    public int getNumberOfFiles()
    {
        int i =files.size();
        return i;
    }
    
    /**
     * List a file from the collection.
     * @param index The index of the file to be listed.
     */
    public void listFile(int index)
    {
        files.get(index).printData();
    }
    
    /**
     * Show a list of all the files in the collection.
     */
    public void listAllFiles()
    {
        for (int i=0;i<files.size();i++) {
            System.out.println("Song "+(i+1)+":");
            files.get(i).printData();
        }
    }
    
    /**
     * Remove a file from the collection.
     * @param index The index of the file to be removed.
     */
    public void removeFile(int index)
    {
       files.remove(index);
    }

    /**
     * Start playing a file in the collection.
     * Use stopPlaying() to stop it playing.
     * @param index The index of the file to be played.
     */
    public void startPlaying(int index)
    {
        if(validIndex(index))
        System.out.println("song "+files.get(index).getName()+" is playing now");
    }

    /**
     * Stop the player.
     */
    public void stopPlaying()
    {
        System.out.println("player is stopped!");
    }


    /**
     * Determine whether the given index is valid for the collection.
     * Print an error message if it is not.
     * @param index The index to be checked.
     * @return true if the index is valid, false otherwise.
     */
    private boolean validIndex(int index)
    {
        // The return value.
        // Set according to whether the index is valid or not.
        if((index>=0)&&(index<files.size()))
            return  true;
        else{
            System.out.println("an error occoured");
            return false;
        }

    }

    /**
     * adds a song to favorite list by its original index
     * @param index
     */
    public void addToFavorateMusics(int index){
        favorateMusics.add(files.get(index));
    }

    /**
     * removes a song in the favorite list by its index
     * @param index
     */
    public void removeFromFavorate(int index){
        favorateMusics.remove(files.get(index));
    }

    /**
     * prints the favorite list
     */
    public void showFavorateList(){
        Iterator<Music> it=favorateMusics.iterator();
        int i=1;
        while(it.hasNext()){
            System.out.println("Song "+i+":");
            it.next().printData();
            i++;
        }
    }

    /**
     * searches a song name and prints all available matched songs
     * @param name
     */
    public void Search(String name){
        Iterator<Music> it=files.iterator();
        while (it.hasNext()){
            if(it.next().getName().equals(name)){
                System.out.println("name :"+it.next().getName());
                System.out.println("address :"+it.next().getAddress());
                System.out.println("producer :"+it.next().getProducer());
            }
        }
    }
    public static void main(String[] args) {
        MusicCollection hiphop = new MusicCollection();
        MusicCollection pop = new MusicCollection();

        hiphop.files.add(new Music("dramasetter","eminem",2013,"E://Musics"));
        hiphop.files.add(new Music("Arcade","duncan Laurence",2020,"E://Musics"));
        hiphop.files.add(new Music("paid my dues","NF",2021,"E://Musics"));
        hiphop.files.add(new Music("drive forever","serigio valentino",2021,"E://Musics"));
        hiphop.files.add(new Music("stereo hearts","gym class heroes",2021,"E://Musics"));
        hiphop.files.add(new Music("Criminal","Eminem",2021,"E://Musics"));
        hiphop.listAllFiles();
        hiphop.removeFile(1);
        System.out.println("");
        System.out.println("");
        System.out.println("");
        hiphop.listAllFiles();
        hiphop.addToFavorateMusics(0);
        hiphop.addToFavorateMusics(1);
        hiphop.addToFavorateMusics(2);
         //hiphop.listAllFiles();
        hiphop.showFavorateList();
        hiphop.removeFromFavorate(0);
        hiphop.showFavorateList();
        hiphop.startPlaying(2);
        hiphop.stopPlaying();
    }
}